<template id="add-article">
    <div>
        <h3>Add new Article</h3>
        <form v-on:submit.prevent="addArticle">
            <div class="form-group">
                <label for="add-title">Title *</label>
                <input id="add-title" v-model="article.title" class="form-control"/>
            </div>
            <div class="form-group">
                <label>Body *</label>
                <textarea class="form-control" rows="10" v-model="article.body"></textarea>
            </div>
            <div v-if="errors.length && errors.length > 0" class="form-group">
                <div class="alert alert-danger">
                    <p><b>Please correct the following error(s):</b></p>
                    <ul>
                        <li v-for="error in errors">{{ error }}</li>
                    </ul>
                </div>
            </div>
            <div class="text-right">
                <button type="submit" class="btn btn-primary">Save</button>
                <router-link class="btn btn-warning" v-bind:to="'/'">Cancel</router-link>
            </div>
        </form>
    </div>
</template>

<script>
  export default {
    data: function () {
      return {
        article: {
          id: '',
          title: '',
          body: ''
        },
        errors: [],
      }
    },
    methods: {
      addArticle() {
        this.errors = [];
        // Check Validate Form
        if (!this.article.title) {
          this.errors.push('Title is required');
        }

        if (!this.article.body) {
          this.errors.push('Body is required');
        }

        if (this.errors.length > 0) {
          return false;
        }

        // Add
        fetch('api/article', {
          method: 'post',
          body: JSON.stringify(this.article),
          headers: {
            'content-type': 'application/json'
          }
        })
          .then(res => res.json())
          .then(data => {
            this.clearForm();
            alert('Article Added');
            this.fetchArticles();
          })
          .catch(err => console.log(err));
      },
    }
  }
</script>